Ruby - Bug #18472

rb_w32_map_errno is not found on Ruby-3.1.0
01/11/2022 02:11 PM - joker1007 (Tomohiro Hashidate)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: ruby 3.1.0p0 (2021-12-25 revision

fb4df44d16) [x64-mingw-ucrt]

Backport:

2.6: UNKNOWN, 2.7: UNKNOWN, 3.0:
UNKNOWN, 3.1: UNKNOWN

Description
| faced Fiddle::DLError such following.

C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/3.1.0/fiddle/import.rb:297:in " import_function'

cannot find the function: rb_w32_map_errno() (Fiddle::DLError)

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/3.1.0/fiddle/import.rb:170:1in

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.1.0/gems/serverengine-2.

rverengine/winsock.rb:112:in "~ <module:RbWinSock>"'

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.1.

rverengine/winsock.rb:97:in ‘<module:ServerEngine>'

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.

rverengine/winsock.rb:18:in "<top (required)>'

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.

rverengine/socket_manager_win.rb:21:in ‘require_relative'

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.

rverengine/socket_manager_win.rb:21:in ‘<top (required)>'

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.

rverengine/socket_manager.rb:222:in ‘require_relative'

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.

rverengine/socket_manager.rb:222:in ‘<module:SocketManager>'

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.

rverengine/socket_manager.rb:26:in ' <module:ServerEngine>'

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.

rverengine/socket_manager.rb:25:in ‘<top (required)>'

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.

rverengine/process_manager.rb:19:in ‘require'

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.

rverengine/process_manager.rb:19:in “<top (required)>'

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.

rverengine/supervisor.rb:20:in ‘require'

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.

rverengine/supervisor.rb:20:in '<top (required)>'

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.

rverengine/daemon.rb:21:in 'require'

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.

rverengine/daemon.rb:21:in “<top (required)>'

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.

rverengine.rb:26:in ~require'

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.

rverengine.rb:26:in ~<module:ServerEngine>'

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.

rverengine.rb:18:in “<top (required)>'

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.

/test/log.rb:17:in “require'

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.

/test/log.rb:17:in “<top (required)>'
from
/test.rb:19:in ‘require'
from
/test.rb:19:in “<top (required)>'
from

from
C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.

0/gems/serverengine-2.

.0/gems/serverengine-2.
.0/gems/serverengine-2.
.0/gems/serverengine-2.
.0/gems/serverengine-2.
.0/gems/serverengine-2.
.0/gems/serverengine-2.
.0/gems/serverengine-2.
.0/gems/serverengine-2.
.0/gems/serverengine-2.
.0/gems/serverengine-2.
.0/gems/serverengine-2.
.0/gems/serverengine-2.
.0/gems/serverengine-2.
.0/gems/serverengine-2.
.0/gems/serverengine-2.

.0/gems/serverengine-2.

D:/a/fluent-plugin-bigquery/fluent-plugin-bigquery/test/helper.rb:6:in "require'
D:/a/fluent-plugin-bigquery/fluent-plugin-bigquery/test/helper.rb:6:in ~<top

“extern'

2.4/1ib/se
2.4/1ib/se

2.4/1ib/se

2.4/1ib/se

2.4/1ib/se
2.4/1ib/se

2.4/1ib/se

2.4/1ib/se

2.4/1ib/se

.0/gems/fluentd-1.14.4/1ib/fluent
.0/gems/fluentd-1.14.4/1ib/fluent
.0/gems/fluentd-1.14.4/1ib/fluent

C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.1.0/gems/fluentd-1.14.4/1ib/fluent

(required) >'
from D:/a/fluent-plugin-bigquery/fluent-plugin-bigquery/test/plugin/test_out_bigquery_base.rb:1:1

n ‘require'

from D:/a/fluent-plugin-bigquery/fluent-plugin-bigquery/test/plugin/test_out_bigquery_base.rb:1:1

n “<top (required)>'

from C:/hostedtoolcache/windows/Ruby/3
_test_loader.rb:21:in ‘require'

from C:/hostedtoolcache/windows/Ruby/3
_test_loader.rb:21:in “block in <main>'

from C:/hostedtoolcache/windows/Ruby/3
_test_loader.rb:6:in "~ select'

.1.0/x64/1ib/ruby/gems/3.
.1.0/x64/1ib/ruby/gems/3.

.1.0/x64/1ib/ruby/gems/3.

.0/gems/rake-13.
.0/gems/rake-13.

.0/gems/rake-13.

.6/1ib/rake/rake

.6/1ib/rake/rake

.6/1ib/rake/rake

.6/1lib/rake/rake

from C:/hostedtoolcache/windows/Ruby/3.1.0/x64/1ib/ruby/gems/3.
_test_loader.rb:6:in ~<main>"'

.0/gems/rake-13.
rake aborted!

The cause code is here. (

https://github.com/treasure-data/serverengine/blob/4d6dbd3d1b4e1af88cc2593b5b19cf0f6da7d5dd/lib/serverengine/winsock.rb#l 11

2)

module RbWinSock
extend Fiddle::Importer

dlload "kernel32"
extern "int GetModuleFileNameA (int, char *, int)"

extern "int CloseHandle (int)"

ruby_bin_path_buf = Fiddle::Pointer.malloc (1000)
GetModuleFileNameA (0, ruby_bin_path_buf, ruby_bin_path_buf.size)

ruby_bin_path = ruby_bin_path_buf.to_s.gsub(/\\/, '/")
ruby_dll_paths = File.dirname (ruby_bin_path) + '/*msvcr*ruby*.dll’'
ruby_dll_path = Dir.glob (ruby_dll_paths).first
dlload ruby_dll_path
extern "int rb_w32_map_errno (int)"

On 3.0.x, this test is passed.

Moreover, | don't find any changes about rb_w32_map_errno from 3.0.3 to 3.1.0.

It is strange behavior. It may be a bug in Ruby-3.1.0

Environment

e Github Actions (windows-latest)
¢ use https://github.com/oneclick/rubyinstaller2/releases/download/Rubylnstaller-3.1.0-1/rubyinstaller-3.1.0-1-x64.7z

e permalink to failed test (
https://github.com/fluent-plugins-nursery/fluent-plugin-bigquery/runs/4775813193?check_suite focus=true)

| apologize for the lack of research, as | do not have a Windows environment.

History

#1 - 01/11/2022 02:11 PM - joker1007 (Tomohiro Hashidate)

- Subject changed from rb_w32_map_errno does not found on Ruby-3.1.0 to rb_w32_map_errno is not found on Ruby-3.1.0

#2 - 01/12/2022 09:57 AM - kubo (Takehiro Kubo)

It is because of a change in rubyinstaller-3.1.0-x64.

In https://rubyinstaller.org/2021/12/31/rubyinstaller-3.1.0-1-released.html:

Rubylnstaller-3.1.0-x64 has a changed C-runtime called UCRT replacing the old MSVCRT.

| guess that ruby_dll_path is nil because *msvcr*ruby*.dll doesn't exist in the bin directory.

rubyinstaller-3.1.0-x64: x64-ucrt-ruby310.dll
rubyinstaller-3.0.0-x64: x64-msvcrt-ruby300.dll
https://github.com/treasure-data/serverengine/blob/4d6dbd3d1b4e1af88cc2593b5b19cf0f6da7d5dd/lib/serverengine/winsock.rb#L112
https://github.com/treasure-data/serverengine/blob/4d6dbd3d1b4e1af88cc2593b5b19cf0f6da7d5dd/lib/serverengine/winsock.rb#L112
https://github.com/oneclick/rubyinstaller2/releases/download/RubyInstaller-3.1.0-1/rubyinstaller-3.1.0-1-x64.7z
https://github.com/fluent-plugins-nursery/fluent-plugin-bigquery/runs/4775813193?check_suite_focus=true
https://rubyinstaller.org/2021/12/31/rubyinstaller-3.1.0-1-released.html

rubyinstaller-3.1.0-x86: msvcrt-ruby310.dll
rubyinstaller-3.0.0-x86: msvcrt-ruby300.dll

How about the following code?

module RbWinSock
extend Fiddle::Importer

dlload "kernel32"
extern "int CloseHandle (int)"

require 'rbconfig'
dlload RbConfig::CONFIG['LIBRUBY_SO']
extern "int rb_w32_map_errno (int)"

#3 - 01/13/2022 09:53 AM - kubo (Takehiro Kubo)

The error itself was fixed by https:/github.com/treasure-data/serverengine/pull/116#issuecomment-1011931598.
There is another error in serverengine using ruby 3.1 but it is unrelated to this issue.

#4 - 01/13/2022 09:59 AM - ashie (Takuro Ashie)

I've released a fixed version of serverengine: https:/rubygems.org/gems/serverengine/versions/2.2.5
Thanks for your report!

#5 - 08/25/2023 05:44 PM - jeremyevans0 (Jeremy Evans)
- Status changed from Open to Closed
